//+------------------------------------------------------------------+
//|                                                 (Demo).mq4 |
//+------------------------------------------------------------------+

//    ,   - http://forum.mql4.com/ru/30433

#property copyright "Dmitriy Vanin"
#property link      "vanin@ftbroker.ru"

extern string _____1_____        = " ";
extern int    Step               = 60;
extern int    TakeProfit         = 100;          // -   
extern double Lot                = 0.1;          //   


extern string _____2_____        = " ";
extern int    MagicNumber        = 20081975;     //   
extern int    Slippage           = 3;            //   
extern int    NumberOfTry        = 5;            //   
bool          gbDisabled         = False;        // 
extern bool   UseSound           = True;         //   
extern string NameFileSound      = "expert.wav"; //   
extern color  clOpenBuy          = LightBlue;    //    Buy
extern color  clOpenSell         = LightCoral;   //    Sell
extern color  clModifyBuy        = LightBlue;    //    Buy
extern color  clModifySell       = LightCoral;   //    Sell
extern color  clCloseBuy         = LightBlue;    //    Buy
extern color  clCloseSell        = LightCoral;   //    Sell

#include <stdlib.mqh>                            //   4

int count = 0, deal_buy, deal_sell; 
double Lots, UpLevel, DownLevel;
datetime TimeFirstPos;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int Nb=openPositionsDet(OP_BUYSTOP);
  int Ns=openPositionsDet(OP_SELLSTOP);
  int Nb0=openPositionsDet(OP_BUY);
  int Ns0=openPositionsDet(OP_SELL);
  double step=Step*Point;

 if(Ns!=0)deal_sell=1; if(deal_sell==1 && Ns==0){
     if (Ns==0 && Ns0!=0) {
         Lots=3*Lot*(count+1);
         SetOrder(Symbol(), OP_BUYSTOP, Lots, UpLevel, 0, 0, MagicNumber, 0);
         deal_sell=0;
         count++;
     }   
  }
  
  if(Nb!=0)deal_buy=1; if(deal_buy==1 && Nb==0){
     if (Nb==0 && Nb0!=0) {
         Lots=3*Lot*(count+1);       
         SetOrder(Symbol(), OP_SELLSTOP, Lots, DownLevel, 0, 0, MagicNumber, 0);
         deal_buy=0;
         count++;
     }   
  }
  
  
  if(Nb==0 && Ns==0 && Nb0==0 && Ns0==0) {
     UpLevel=Ask;
     DownLevel=Bid-step;
     if(iClose(Symbol(),-1,1)<=iOpen(Symbol(),-1,1)){
     UpLevel=Ask;
     DownLevel=Bid-step;
     OpenPosition(Symbol(), OP_BUY, Lot, 0, 0, MagicNumber);
     SetOrder(Symbol(), OP_SELLSTOP, 2*Lot, Bid-step, 0, 0, MagicNumber, 0);
     count=0;
     }
     if(iClose(Symbol(),-1,1)>iOpen(Symbol(),-1,1)){
     UpLevel=Ask+step;
     DownLevel=Bid;
     OpenPosition(Symbol(), OP_SELL, Lot, 0, 0, MagicNumber);
     SetOrder(Symbol(), OP_BUYSTOP, 2*Lot, Ask+step, 0, 0, MagicNumber, 0);
     count=0;
     }
  }
 
 if(GetProfitOpenPosInCurrency(NULL,OP_BUY,MagicNumber)+GetProfitOpenPosInCurrency(NULL,OP_SELL,MagicNumber)>=TakeProfit){
     ClosePosFirstProfit(NULL,-1,MagicNumber);
     CloseBuyStopOrder();
     CloseSellStopOrder();
  }

/*  if(GetProfitOpenPosInCurrency(NULL,OP_BUY,MagicNumber)+GetProfitOpenPosInCurrency(NULL,OP_SELL,MagicNumber)>0){
    CloseBuyStopOrder();
    CloseSellStopOrder();
    if(GetProfitOpenPosInCurrency(NULL,OP_BUY,MagicNumber)>0){
       ClosePosFirstProfit(NULL,OP_SELL,MagicNumber);
       TrailingPositions(GetTicketLastPos(Symbol(), OP_BUY, MagicNumber));*/

   return(0);
   
  }
//+----  Start-----------------------------------------------------------------------------------------+  
   
//+---- -------------------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetProfitOpenPosInCurrency(string sy="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            p+=OrderProfit()+OrderCommission()+OrderSwap();
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, datetime ex=0) {
  color clOpen;
  int   err, ticket;
 
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
  ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn, ex, clOpen);
  if (ticket<0) {
    err=GetLastError();
    Print("Error(",err,") set ",GetNameOP(op),": ",ErrorDescription(err));
    Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
          " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePosFirstProfit(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();

  //    
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (OrderProfit()+OrderSwap()>0) ClosePosBySelect();
          }
        }
      }
    }
  }
  //   
  k=OrdersTotal();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  double pp;

  if (OrderType()==OP_BUY) {
    pp=MarketInfo(OrderSymbol(), MODE_BID);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
  }
  if (OrderType()==OP_SELL) {
    pp=MarketInfo(OrderSymbol(), MODE_ASK);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
  }
}
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                             |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ( ""  -  ,                   |
//|                                     NULL -  )                 |
//|    op -            ( -1  -  )                  |
//|    mn - MagicNumber                ( -1  -  )                    |
//+----------------------------------------------------------------------------+
double GetAmountLotFromOpenPos(string sy="", int op=-1, int mn=-1) {
  double l=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              l+=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}
/*//+------------------------------------------------------------------+ 
//|                                 | 
//+------------------------------------------------------------------+ 
void TrailingPositions(int orderTicket) { 
  double pBid, pAsk, pp, TrailingStop; 
  pp = MarketInfo(OrderSymbol(), MODE_POINT); 
  if (OrderType()==OP_BUY) { 
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    TrailingStop = (OrderTakeProfit()-pBid)/Point;// 
    if(TrailingStop<StopLevel) {TrailingStop=StopLevel+Spread;}  
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) { 
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) { 
        ModifyStopLoss(pBid-TrailingStop*pp, orderTicket); 
        return; 
      } 
    } 
  } 
  if (OrderType()==OP_SELL) { 
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    TrailingStop = (pAsk-OrderTakeProfit())/Point;
    if(TrailingStop<StopLevel) {TrailingStop=StopLevel+Spread;}  
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) { 
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) { 
        ModifyStopLoss(pAsk+TrailingStop*pp, orderTicket); 
        return; 
      } 
    } 
  } 
}*/
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  color  clOpen;
  double pp;
  int    err, ticket;
 
  if (sy=="") sy=Symbol();
  if (op==OP_BUY) {
    pp=MarketInfo(sy, MODE_ASK); clOpen=clOpenBuy;
  } else {
    pp=MarketInfo(sy, MODE_BID); clOpen=clOpenSell;
  }
  ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn, 0, clOpen);
  if (ticket<0) {
    err=GetLastError();
    Print("Error(",err,") open ",GetNameOP(op),": ",ErrorDescription(err));
    Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
          " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :       -1             |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetTicketLastPos(string sy="", int op=-1, int mn=-1) {
  datetime o;
  int      i, k=OrdersTotal(), r=-1;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (o<OrderOpenTime()) {
                o=OrderOpenTime();
                r=OrderTicket();
              }
            }
          }
        }
      }
    }
  }
  return(r);
}
//+----------------------------------------------------------------------------+
int openPositionsDet(int ORDER)
{  int op =0;
     for(int i=OrdersTotal()-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() )
         {  
          if (OrderType() == ORDER) op++; 
         }
      } 
   return(op);
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
int CloseBuyStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_BUYSTOP) { 
            OrderDelete(OrderTicket(),Green);
          }
        }
    } 
    return(0);
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
int CloseSellStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_SELLSTOP) { 
            OrderDelete(OrderTicket(),Red);
          }
        }
    } 
    return(0);
}
//+----------------------------------------------------------------------------+